program psici;
const 
	EPS = 1.0E-6;	{max. chyba vzniknuta v realnych cislach}
	MAX_V = 16;	{najvacsia mozna vrstva (aj so zarazkou)}
	MAX_STAVOV = MAX_V*MAX_V*MAX_V*MAX_V;
	INF = 99999999;	{najvacsi mozny pocet skokov}
	MAX_SMER = 6;	{pocet smerov, ktorymi sa mozu psici hybat}

type 
	TSur = 	record {suradnice jedneho psika}
		x,y : integer;
	end;
	TStav = record {suradnice dvoch psikov}
		p1, p2 : TSur;
	end;
	{priestor pre 2 psikov: [x1,y1,x2,y2] hovori, ci tam mozu byt}
	TMriezka = array [-MAX_V..MAX_V, -MAX_V..MAX_V,
		-MAX_V..MAX_V, -MAX_V..MAX_V] of longint;

function dekVrstvu(k:integer) : integer;
begin	{cislo vrstvy, kde sa k nachadza}
	dekVrstvu:= trunc(0.5 + sqrt(k/3.0 - 1.0/12.0 - EPS) );
end;
function zakVrstvu(v: integer) : integer;
begin	{posledny prvok na danej vrstve}
	zakVrstvu:= 3*v*v - 3*v +1;
end;

{Dekoduj cislo policka na suradnice v mriezke}
function dekoduj(k:integer) : TSur;
var
	v, pv, s, ps : integer; 
	sur : TSur;
begin
	if (k=1) then begin
		sur.x:=0; sur.y:=0; dekoduj:=sur; exit;
	end;
	
	v:= dekVrstvu(k);
	{pozicia na vrstve}
	pv:= k - (3*v*v - 3*v + 1) - 1;
	{strana sestuholnika, kde sa pv nachadza}
	s:= pv div v;
	{pozicia na strane sestuholnika}
	ps:= pv mod v;

	case s of
	0: begin sur.x:= +v-1-ps; sur.y:= +v     ; end;
	1: begin sur.x:=   -1-ps; sur.y:= +v-1-ps; end;
	2: begin sur.x:= -v     ; sur.y:=   -1-ps; end;
	3: begin sur.x:= -v+1+ps; sur.y:= -v     ; end;
	4: begin sur.x:=   +1+ps; sur.y:= -v+1+ps; end;
	5: begin sur.x:= +v     ; sur.y:=   +1+ps; end;
	else writeln('Velka chyba v dekoduj');
	end;
	dekoduj:=sur;
end;

var 	{vstup}
	n, m, s1, t1, s2, t2 : integer;
	{max. pouzita vrstva pre dane n}
	v : integer;
	{prehladavany priestor}
	A : TMriezka;

{zakaze vsetky situacie, kde sa nachadza bodliak na danom mieste}
procedure pridajBodliak( b : TSur );
var x, y : integer;
begin
	for x:= -v to v do for y:= -v to v do begin
		A[x, y, b.x, b.y]:= INF;	{2. psik stoji na bodliaku}
		A[b.x, b.y, x, y]:= INF;	{1. psik stoji na bodliaku}
	end;
end;

{vycisti cely prehladavany priestor}
procedure inicializacia;
var x1, y1, x2, y2, i, last : integer;
begin
	{vycistenie priestoru}
	for x1:= -v to v do for y1:= -v to v do
		for x2:= -v to v do for y2:= -v to v do
			A[x1, y1, x2, y2]:= -1;

	{zarazky po okrajoch - pridame umelo bodliaky}
	last:=zakVrstvu(v+2);
	for i:=n+1 to last do
		pridajBodliak( dekoduj(i) );

	{zakazeme byt obidvom psikom na tom istom mieste}
	for x1:= -v to v do for y1:= -v to v do
		A[x1, y1, x1, y1]:= INF;
end;

{Posunutie suradnice danynm smerom}
function pohyb( a : TSur; s:integer) : TSur;
const smer : array [1..MAX_SMER] of TSur = ( 
	(x: 0;y: 1), (x:-1;y: 0), (x:-1; y:-1),
	(x: 0;y:-1), (x: 1;y: 0), (x: 1; y: 1) );
begin
	a.x:= a.x+smer[s].x;
	a.y:= a.y+smer[s].y;
	pohyb:=a;	
end;

{obcas su problemy, ked sa na zasobnik natrepe vela dat, tak je mimo zasobnika}
var F:array [0..MAX_STAVOV] of TStav;	{prehladavany priestor}
{prehladavanie priestoru, kde sa mozu psici nachadzat, do sirky}
function pracuj : integer;
var 
	zac : integer;	{pozicia prveho prvku vo fronte} 
	kon : integer;	{pozicia za poslednym prvkom vo fronte = volne miesto}
	i, j, vzd : integer;
	p1, p2, q1, q2 : TSur;
	pt1, pt2 : TSur;	{dekodovane pozicie skrys pre psikov}
begin
	zac:=0; kon:=1;	{pridame zaciatok do fronty}
	p1:= dekoduj(s1);
	p2:= dekoduj(s2);
	F[zac].p1:= p1;	F[zac].p2:= p2;
	A[ p1.x, p1.y, p2.x, p2.y ]:= 0;	{zaciname vo vzdial. 0}
	
	pt1:=dekoduj(t1); pt2:=dekoduj(t2);
	
	while (zac<>kon) do begin
		{vyberame stav z fronty a najdeme k nemu vzdialenost}
		p1:=F[zac].p1; p2:=F[zac].p2;
		vzd:= A[ p1.x, p1.y, p2.x, p2.y ];
		inc(zac);

		{skusame vsetky kombinacie smerov, kam mozu skakat}
		for i:=1 to MAX_SMER do for j:=1 to MAX_SMER do begin
			if (i=j) then continue;	{nemozu skakat rovnako}

			{nove pozicie psikov}
			q1:= pohyb( p1, i );
			q2:= pohyb( p2, j );
			
			{uz videna pozicia resp. zarazka ?}
			if (A[ q1.x, q1.y, q2.x, q2.y ] >= 0 ) then continue; 

			{novo objaveny stav -> pridame do fronty}
			A[ q1.x, q1.y, q2.x, q2.y ]:= vzd+1; 
			F[kon].p1:=q1; F[kon].p2:=q2;
			inc(kon);

			{nasli sme koncovy stav?}
			if (pt1.x=q1.x) and (pt1.y=q1.y) and 
				(pt2.x=q2.x) and (pt2.y=q2.y) 
			then begin
				pracuj:=vzd+1; exit;
			end;
		end;
	end;
	pracuj:= -1;
end;

var	x, i : integer;
	ss : TSur;
begin
	assign(input, 'psici.in');
	assign(output, 'psici.out');
	reset(input);
	rewrite(output);
	while (true) do begin
		readln( n, m );
		if ( (n=0) and (m=0) ) then break;
		
		v:= dekVrstvu(n);
		inicializacia();

		readln( s1, t1, s2, t2 );
		for i:=1 to m do begin
			read( x );
			pridajBodliak( dekoduj(x) );
		end;

		if (s1=t1) and (s2=t2) then
			x:=0	{specialny pripad}
		else
			x:=pracuj;

		if (x>=0) then 
			writeln(x)
		else
			writeln('nelze');

	end;
	close(output);
end.
